## clblas 2.12

=== src/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

cmake_minimum_required(VERSION 2.8)

#User toggle-able options that can be changed on the command line with -D
option( BUILD_RUNTIME "Build the BLAS runtime library" ON )
option( BUILD_TEST "Build the library testing suite (dependency on google test, Boost, and ACML/NETLIB BLAS)" ON )
option( BUILD_PERFORMANCE "Copy the performance scripts that can measure and graph performance" OFF )
option( BUILD_SAMPLE "Build the sample programs" OFF )
option( BUILD_CLIENT "Build a command line clBLAS client program with a variety of configurable parameters (dependency on Boost)" OFF )
option( BUILD_KTEST "A command line tool for testing single clBLAS kernel" ON )
option( BUILD_SHARED_LIBS "Build shared libraries" ON )

#enable or disable offline compilation for different devices. Currently only Hawaii, Bonaire, Tahiti have the option.
#option( OPENCL_OFFLINE_BUILD_HAWAII_KERNEL "Offline compile the OpenCL kernels for Hawaii device" OFF)
#option( OPENCL_OFFLINE_BUILD_BONAIRE_KERNEL "Offline compile the OpenCL kernels for Bonaire device" OFF)
#option( OPENCL_OFFLINE_BUILD_TAHITI_KERNEL "Offline compile the OpenCL kernels for Tathit device" OFF)
set( OPENCL_OFFLINE_BUILD_HAWAII_KERNEL OFF)
set( OPENCL_OFFLINE_BUILD_BONAIRE_KERNEL OFF)
set( OPENCL_OFFLINE_BUILD_TAHITI_KERNEL OFF)

#if( (OPENCL_OFFLINE_BUILD_HAWAII_KERNEL AND OPENCL_OFFLINE_BUILD_BONAIRE_KERNEL) OR (OPENCL_OFFLINE_BUILD_HAWAII_KERNEL AND OPENCL_OFFLINE_BUILD_TAHITI_KERNEL) OR (OPENCL_OFFLINE_BUILD_BONAIRE_KERNEL AND OPENCL_OFFLINE_BUILD_TAHITI_KERNEL))
#   MESSAGE( WARNING "More than one device is chosen for offline compilation of static kernels. This might result in running out of heap memory with certain driver. Please consider offline compliation for ONE device only." )
#endif( )

#if( NOT OPENCL_OFFLINE_BUILD_HAWAII_KERNEL )
  #use dynamic generated kernels
#  MESSAGE(STATUS "Build dynamic Hawaii kernels.")
#  MESSAGE(STATUS "Check OPENCL_OFFLINE_BUILD_HAWAII_KERNEL to build kernls at compile-time. This will eliminates clBuildProgram() overhead and better kernel performance with certain driver.")
  add_definitions(-DCLBLAS_HAWAII_DYNAMIC_KERNEL)
#else()
#  MESSAGE(STATUS "Build static Hawaii kernels.")
#  MESSAGE(STATUS "Uncheck OPENCL_OFFLINE_BUILD_HAWAII_KERNEL to build kernls at run-time")
#  MESSAGE(STATUS "Please ensure the presence of Hawaii device in the system. With certain driver/compiler flags, this might result in compile-time error.")
#endif( )

#if( NOT OPENCL_OFFLINE_BUILD_BONAIRE_KERNEL )
  #use dynamic generated kernels
#  MESSAGE(STATUS "Build dynamic Bonaire kernels.")
#  MESSAGE(STATUS "Check OPENCL_OFFLINE_BUILD_BONAIRE_KERNEL to build kernls at compile-time. This will eliminates clBuildProgram() overhead and better kernel performance with certain driver.")
  add_definitions(-DCLBLAS_BONAIRE_DYNAMIC_KERNEL)
#else()
#  MESSAGE(STATUS "Build static Bonaire kernels.")
#  MESSAGE(STATUS "Uncheck OPENCL_OFFLINE_BUILD_BONAIRE_KERNEL to build kernls at run-time")
#  MESSAGE(STATUS "Please ensure the presence of Bonaire device in the system. With certain driver/compiler flags, this might result in compile-time error.")
#endif( )

#if( NOT OPENCL_OFFLINE_BUILD_TAHITI_KERNEL )
  #use dynamic generated kernels
#  MESSAGE(STATUS "Build dynamic Tahiti kernels.")
#  MESSAGE(STATUS "Check OPENCL_OFFLINE_BUILD_TAHITI_KERNEL to build kernls at compile-time. This will eliminates clBuildProgram() overhead and better kernel performance with certain driver.")
  add_definitions(-DCLBLAS_TAHITI_DYNAMIC_KERNEL)
#else( )
#  MESSAGE(STATUS "Build static Tahiti kernels.")
#  MESSAGE(STATUS "Uncheck OPENCL_OFFLINE_BUILD_TAHITI_KERNEL to build kernls at run-time")
#  MESSAGE(STATUS "Please ensure the presence of Tahiti device in the system. With certain driver/compiler flags, this might result in compile-time error.")
#endif( )


# Ask the user to verify compiler version. If OpenCL 2.0 is supported. Certain public flags can be user
set( OPENCL_VERSION "1.2" CACHE STRING "The version of OpenCL supported by your driver/device" )
set_property( CACHE OPENCL_VERSION PROPERTY STRINGS 2.0 1.2 1.1 )
message( STATUS "You have confirmed OpenCL ${OPENCL_VERSION} is supported in your system" )

# By default test-correctness is linked and tested against ACML library.
# However, test-correctness can instead use NETLIB as a reference library
# On Mac OSX systems, this must be set to OFF for the build to succeed (due to nesting of FindBLAS code)
if ( APPLE )
	set(CORR_TEST_WITH_ACML OFF CACHE BOOL "Use ACML library in correctness tests")
else ( )
	message(STATUS "CORR_TEST_WITH_ACML set to OFF. Try link with libblas.so")
	set(CORR_TEST_WITH_ACML OFF CACHE BOOL "Use ACML library in correctness tests")
endif( )

if( CMAKE_GENERATOR MATCHES "NMake" )
  option( NMAKE_COMPILE_VERBOSE "Print compile and link strings to the console" OFF )
  if( NMAKE_COMPILE_VERBOSE )
    set( CMAKE_START_TEMP_FILE "" )
    set( CMAKE_END_TEMP_FILE "" )
    set( CMAKE_VERBOSE_MAKEFILE 1 )
  endif( )
endif( )

# If we are on linux, and we wish to link with the netlib BLAS implementation when BUILD_TEST is ON, we need to have a valid fortran compiler
if(BUILD_TEST AND NOT CORR_TEST_WITH_ACML AND NOT WIN32 AND NOT APPLE)
  project(clBLAS Fortran C CXX )
else( )
  project(clBLAS C CXX)
endif( )

# Define a version for the code
if( NOT DEFINED clBLAS_VERSION_MAJOR )
    set( clBLAS_VERSION_MAJOR 2 )
endif( )

if( NOT DEFINED clBLAS_VERSION_MINOR )
    set( clBLAS_VERSION_MINOR 12 )
endif( )

if( NOT DEFINED clBLAS_VERSION_PATCH )
    set( clBLAS_VERSION_PATCH 0 )
endif( )

set( clBLAS_VERSION "${clBLAS_VERSION_MAJOR}.${clBLAS_VERSION_MINOR}.${clBLAS_VERSION_PATCH}")

# Increment this if we break backward compatibility.
set( clBLAS_SOVERSION 2 )

# We have custom written Find* modules now in the root source directory
set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR} )

# On windows, it's convenient to change the default install prefix such that it does NOT point to 'program files' (permissions problems)
# Need to check out CMAKE_RUNTIME_OUTPUT_DIRECTORY variable, and see if that eliminates the need to modify install path
if( WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT )
	set( CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}/package" CACHE PATH "Install path prefix, prepended onto install directories" FORCE )
endif( )

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif()

# These variables are meant to contain string which should be appended to the installation paths
# of library and executable binaries, respectively.  They are meant to be user configurable/overridable.
set( SUFFIX_LIB_DEFAULT "" )
set( SUFFIX_BIN_DEFAULT "" )

if(TARGET_PLATFORM EQUAL 32 OR TARGET_PLATFORM EQUAL 64)
    set(TARGET_PLATFORM ${TARGET_PLATFORM} CACHE STRING "Target platform type (32-bit or 64-bit)" FORCE)
else()
    if(CMAKE_SIZEOF_VOID_P MATCHES 8)
        set(TARGET_PLATFORM "64" CACHE STRING "Target platform type (32-bit or 64-bit)" FORCE)
    else()
        set(TARGET_PLATFORM "32" CACHE STRING "Target platform type (32-bit or 64-bit)" FORCE)
    endif()
endif()

message(STATUS "Target platform: ${TARGET_PLATFORM}-bit")
if(TARGET_PLATFORM EQUAL 32)
    set(_arch "x86" INTERNAL)
    set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS FALSE)
else()
    set(_arch "x86_64" INTERNAL)
    set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE)
    if( NOT APPLE )
        set( SUFFIX_LIB_DEFAULT "64" )
    endif( )
endif()

set( SUFFIX_LIB ${SUFFIX_LIB_DEFAULT} CACHE STRING "String to append to 'lib' install path" )
set( SUFFIX_BIN ${SUFFIX_BIN_DEFAULT} CACHE STRING "String to append to 'bin' install path" )

if( MSVC_IDE )
    set_property( GLOBAL PROPERTY USE_FOLDERS TRUE )
endif( )

# add the math library for Linux
if( UNIX )
    set(MATH_LIBRARY "m")
    set(THREAD_LIBRARY "pthread")
endif()

# set the path to specific OpenCL compiler
set( OPENCL_COMPILER_DIR "OPENCL COMPILER PATH" CACHE PATH "OPENCL COMPILER PATH")
if ( ${OPENCL_COMPILER_DIR} STREQUAL "OPENCL COMPILER PATH")
    message( STATUS "Using default OpenCL Compiler")
	  set(ENV_PATH "$ENV{PATH}")
else ()
    message( STATUS "OPENCL COMPILER: ${OPENCL_COMPILER_DIR}")
	if(UNIX)
	  set(ENV_PATH "${OPENCL_COMPILER_DIR}")
	else()
	  set(ENV_PATH "${OPENCL_COMPILER_DIR}")
	endif()
endif()

# Find the BLAS library
# TODO: maybe this could be written using the FindBLAS module in the future
if( BUILD_TEST )
	if(NOT CORR_TEST_WITH_ACML)
	    if(APPLE)
			find_library(BLAS_LIBRARIES Accelerate HINTS /System/Library/Frameworks/Accelerate.framework)
		       	MARK_AS_ADVANCED(BLAS_LIBRARIES)
		       	message(STATUS "Using Accelerate framework on Mac OS-X")
	    else()
			find_package( Netlib COMPONENTS BLAS REQUIRED )
        endif()
		else( )
		# Find ACML BLAS implementation
		# platform dependent ACML subdirectory
		if (WIN32)
			set(ACML_SUBDIR ifort${TARGET_PLATFORM}_mp)
		else()
		   set(ACML_SUBDIR gfortran${TARGET_PLATFORM}_mp)
		endif()

		find_path(ACML_INCLUDE_DIRS acml.h
			HINTS
				${ACML_ROOT}/include
				${ACML_ROOT}/${ACML_SUBDIR}/include
				$ENV{ACML_ROOT}/include
                                $ENV{ACML_ROOT}/${ACML_SUBDIR}/include
		)

		if( ACML_INCLUDE_DIRS )
		else()
			message(WARNING "Cannot find acml.h")
		endif()

		if( UNIX )
			find_library(ACML_LIBRARIES acml_mp
				HINTS
					${ACML_ROOT}/lib
					${ACML_ROOT}/${ACML_SUBDIR}/lib
					$ENV{ACML_ROOT}/lib
                                        $ENV{ACML_ROOT}/${ACML_SUBDIR}/lib
			)
			find_library(_acml_mv_library acml_mv
				HINTS
					${ACML_ROOT}/lib
					${ACML_ROOT}/${ACML_SUBDIR}/lib
					$ENV{ACML_ROOT}/lib
                                        $ENV{ACML_ROOT}/${ACML_SUBDIR}/lib
			)
			mark_as_advanced(_acml_mv_library)
		endif( )

		if(WIN32)
			find_library(ACML_LIBRARIES libacml_mp_dll
				HINTS
					${ACML_ROOT}/lib
					${ACML_ROOT}/${ACML_SUBDIR}/lib
					$ENV{ACML_ROOT}/lib
                                        $ENV{ACML_ROOT}/${ACML_SUBDIR}/lib
			)
		endif( )

		if( NOT ACML_LIBRARIES )
			message(WARNING "Cannot find libacml")
		endif( )

		if(ACML_INCLUDE_DIRS AND ACML_LIBRARIES)
			if(_acml_mv_library)
				list(APPEND ACML_LIBRARIES ${_acml_mv_library})
			endif()
			message(STATUS "Found ACML: ${ACML_LIBRARIES}")
			set(ACML_FOUND TRUE BOOL "Found the ACML package")
		endif()
		mark_as_advanced(ACML_FOUND ACML_INCLUDE_DIRS ACML_LIBRARIES)

	endif( )
endif( )

if( BUILD_CLIENT )
    if( NETLIB_FOUND )
    else( )
        message( WARNING "Not find Netlib; BUILD_CLIENT needs the Netlib CBLAS library" )
    endif()
endif()


# This will define OPENCL_FOUND
find_package( OpenCL ${OPENCL_VERSION} )

# Find Boost on the system, and configure the type of boost build we want
set( Boost_USE_MULTITHREADED ON )
set( Boost_USE_STATIC_LIBS   ON )
set( Boost_DETAILED_FAILURE_MSG   ON )
# set( Boost_DEBUG ON )
set( Boost_ADDITIONAL_VERSIONS "1.44.0" "1.44" "1.47.0" "1.47" "1.60.0" "1.60" )

find_package( Boost 1.33.0 COMPONENTS program_options )
message(STATUS "Boost_PROGRAM_OPTIONS_LIBRARY: ${Boost_PROGRAM_OPTIONS_LIBRARY}")


if( NOT Boost_FOUND )

=== src/client/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

set(CLIENT_SRC client.cpp stdafx.cpp statisticalTimer.cpp)
set(CLIENT_HEADER
    stdafx.h
    targetver.h
    statisticalTimer.h
    clfunc_common.hpp
    clfunc_xgemm.hpp
    clfunc_xgemv.hpp
    clfunc_xsymv.hpp
    clfunc_xtrmm.hpp
    clfunc_xtrsm.hpp
    clfunc_xsyrk.hpp
    clfunc_xsyr2k.hpp
	clfunc_xhemm.hpp
	clfunc_xsymm.hpp
	clfunc_xherk.hpp
	clfunc_xher2k.hpp)

set(WRAPPER_SRC testPerfWrapper.cpp)

add_definitions(-D_CRT_SECURE_NO_WARNINGS)

# Having problems on build server, compiling gtest headers with -pedantic; disabling detection of long long
# http://code.google.com/p/googletest/issues/detail?id=334
if( CMAKE_COMPILER_IS_GNUCXX )
	add_definitions( -Wno-long-long )
endif( )

include_directories(
    ${Boost_INCLUDE_DIRS}
    ${OPENCL_INCLUDE_DIRS}
    ${clBLAS_SOURCE_DIR}
    ${clBLAS_SOURCE_DIR}/include
    ${clBLAS_SOURCE_DIR}/tests/include
    ${Netlib_INCLUDE_DIRS}
    .)

add_executable(client ${CLIENT_SRC} ${CLIENT_HEADER})
target_link_libraries(client  ${Netlib_LIBRARIES} ${Boost_LIBRARIES} ${OPENCL_LIBRARIES} clBLAS)
set_target_properties( client PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging"
  OUTPUT_NAME clBLAS-client )

add_executable(testPerfWrapper ${WRAPPER_SRC})
target_link_libraries(testPerfWrapper ${Boost_LIBRARIES})
set_target_properties( testPerfWrapper PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

# CPack configuration; include the executable into the package
install( TARGETS client testPerfWrapper
		RUNTIME DESTINATION bin${SUFFIX_BIN}
		LIBRARY DESTINATION lib${SUFFIX_LIB}
		ARCHIVE DESTINATION lib${SUFFIX_LIB}/import
		)

=== src/library/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

find_package(PythonInterp REQUIRED)



################################################################################
# AutoGemm Begin
################################################################################

# AutoGemm scripts and out files
set(AUTOGEMM_SCRIPTS
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/AutoGemm.py
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/AutoGemmParameters.py
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/Common.py
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/Includes.py
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/KernelOpenCL.py
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/KernelParameters.py
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/KernelSelection.py
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/KernelsToPreCompile.py
)
set(AUTOGEMM_HEADERS
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmClKernels.h
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelBuildOptionsBinary.h
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelBinaries.h
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelSelection.h
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelSelectionSpecific.h
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelBuildOptionsSource.h
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelSources.h
)

set(AUTOGEMM_SRC
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmClKernels.cpp
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelBuildOptionsBinary.cpp
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelBinaries.cpp
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelSelection.cpp
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelSelectionSpecific.cpp
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelBuildOptionsSource.cpp
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelSources.cpp
)

set(USERGEMM_SRC
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/UserGemmKernelSources/UserGemmClKernels.cc
)

set(USERGEMM_HEADERS
   ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/UserGemmKernelSources/UserGemmKernelSourceIncludes.h
   ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/UserGemmKernelSources/UserGemmClKernels.h
)

set(AUTOGEMM_TEST_SRC
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/AutoGemmTools/TestAutoGemm.cpp
)
set(AUTOGEMM_PROFILER_SRC
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/AutoGemmTools/ProfileAutoGemm.cpp
)
set(AUTOGEMM_PRECOMPILE_SRC
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/AutoGemmTools/AutoGemmPreCompileKernels.cpp
)
set( AUTOGEMM_PRECOMPILED_KERNELS
  ${CMAKE_BINARY_DIR}/include/AutoGemmKernelBinaries/AutoGemmKernelBinariesPreCompiled.h
)

# AutoGemm options for pre-compiling kernels
option( PRECOMPILE_GEMM_PRECISION_SGEMM "AutoGemm: pre-compile sgemm kernels" OFF)
option( PRECOMPILE_GEMM_PRECISION_DGEMM "AutoGemm: pre-compile dgemm kernels" OFF)
option( PRECOMPILE_GEMM_PRECISION_CGEMM "AutoGemm: pre-compile cgemm kernels" OFF)
option( PRECOMPILE_GEMM_PRECISION_ZGEMM "AutoGemm: pre-compile zgemm kernels" OFF)

option( PRECOMPILE_GEMM_TRANS_NN "AutoGemm: pre-compile NN transpose cases" OFF)
option( PRECOMPILE_GEMM_TRANS_NT "AutoGemm: pre-compile NT transpose cases" OFF)
option( PRECOMPILE_GEMM_TRANS_NC "AutoGemm: pre-compile NC transpose cases" OFF)
option( PRECOMPILE_GEMM_TRANS_TN "AutoGemm: pre-compile TN transpose cases" OFF)
option( PRECOMPILE_GEMM_TRANS_TT "AutoGemm: pre-compile TT transpose cases" OFF)
option( PRECOMPILE_GEMM_TRANS_TC "AutoGemm: pre-compile TC transpose cases" OFF)
option( PRECOMPILE_GEMM_TRANS_CN "AutoGemm: pre-compile CN transpose cases" OFF)
option( PRECOMPILE_GEMM_TRANS_CT "AutoGemm: pre-compile CT transpose cases" OFF)
option( PRECOMPILE_GEMM_TRANS_CC "AutoGemm: pre-compile CC transpose cases" OFF)

option( INSTALL_SRC "Install source tree" OFF )

set( AUTOGEMM_ARCHITECTURE "Hawaii" CACHE STRING "AutoGemm: device for kernel selection logic" )
set_property( CACHE AUTOGEMM_ARCHITECTURE PROPERTY STRINGS "Hawaii" "Fiji" )



# opencl compiler version
#set( PRECOMPILE_GEMM_OPENCL_VERSION "2.0" CACHE STRING "OpenCL compiler version supported by device driver." )
#set_property( CACHE PRECOMPILE_GEMM_OPENCL_VERSION PROPERTY STRINGS 2.0 1.2 1.1 )
#message( STATUS "AutoGemm PreCompiler will use OpenCL ${PRECOMPILE_GEMM_OPENCL_VERSION} compiler." )

# PreCompile precision selected?
set( PRECOMPILE_GEMM_PRECISION_SELECTED OFF)
if (   PRECOMPILE_GEMM_PRECISION_SGEMM
    OR PRECOMPILE_GEMM_PRECISION_DGEMM
    OR PRECOMPILE_GEMM_PRECISION_CGEMM
    OR PRECOMPILE_GEMM_PRECISION_ZGEMM )
  set( PRECOMPILE_GEMM_PRECISION_SELECTED ON)
endif()

# PreCompile transpose selected?
set( PRECOMPILE_GEMM_TRANS_SELECTED OFF)
if (   PRECOMPILE_GEMM_TRANS_NN
    OR PRECOMPILE_GEMM_TRANS_NT
    OR PRECOMPILE_GEMM_TRANS_NC
    OR PRECOMPILE_GEMM_TRANS_TN
    OR PRECOMPILE_GEMM_TRANS_TT
    OR PRECOMPILE_GEMM_TRANS_TC
    OR PRECOMPILE_GEMM_TRANS_CN
    OR PRECOMPILE_GEMM_TRANS_CT
    OR PRECOMPILE_GEMM_TRANS_CC )
  set( PRECOMPILE_GEMM_TRANS_SELECTED ON)
endif()

# PreCompile is valid and active?
set( PRECOMPILE_GEMM_ACTIVE OFF)
if ( PRECOMPILE_GEMM_PRECISION_SELECTED
    AND PRECOMPILE_GEMM_TRANS_SELECTED)
  # valid selection
  set( PRECOMPILE_GEMM_ACTIVE ON)
  MESSAGE( STATUS "AutoGemm-PreCompile: selected kernels will be pre-compiled." )
elseif(NOT PRECOMPILE_GEMM_PRECISION_SELECTED
    AND NOT PRECOMPILE_GEMM_TRANS_SELECTED)
  MESSAGE( STATUS "AutoGemm-PreCompile: no kernels to be pre-compiled." )
else()
  MESSAGE( SEND_ERROR "AutoGemm-PreCompile: To pre-compile gemm kernels, select at lease one option from each of PRECOMPILE_GEMM_PRECISION_* and PRECOMPILE_GEMM_TRANS_*; otherwise, unselect all PRECOMPILE_GEMM_* options to not pre-compile any gemm kernels." )
endif()

# build commandline argument for AutoGemm
set( AGPC_ARGS --output ${CMAKE_BINARY_DIR}/include )

if ( PRECOMPILE_GEMM_ACTIVE )
  # precisions
  set(AGPC_ARGS ${AGPC_ARGS} --precisions )
  if (PRECOMPILE_GEMM_PRECISION_SGEMM)
    set(AGPC_ARGS ${AGPC_ARGS} s )
  endif()
  if (PRECOMPILE_GEMM_PRECISION_DGEMM)
    set(AGPC_ARGS ${AGPC_ARGS} d )
  endif()
  if (PRECOMPILE_GEMM_PRECISION_CGEMM)
    set(AGPC_ARGS ${AGPC_ARGS} c )
  endif()
  if (PRECOMPILE_GEMM_PRECISION_ZGEMM)
    set(AGPC_ARGS ${AGPC_ARGS} z )
  endif()

  # orders
  set(AGPC_ARGS ${AGPC_ARGS} --orders clblasColumnMajor )

  # transposes
  set(AGPC_ARGS ${AGPC_ARGS} --transposes )
  if (PRECOMPILE_GEMM_TRANS_NN)
    set(AGPC_ARGS ${AGPC_ARGS} NN )
  endif()
  if (PRECOMPILE_GEMM_TRANS_NT)
    set(AGPC_ARGS ${AGPC_ARGS} NT )
  endif()
  if (PRECOMPILE_GEMM_TRANS_NC)
    set(AGPC_ARGS ${AGPC_ARGS} NC )
  endif()
  if (PRECOMPILE_GEMM_TRANS_TN)
    set(AGPC_ARGS ${AGPC_ARGS} TN )
  endif()
  if (PRECOMPILE_GEMM_TRANS_TT)
    set(AGPC_ARGS ${AGPC_ARGS} TT )
  endif()
  if (PRECOMPILE_GEMM_TRANS_TC)
    set(AGPC_ARGS ${AGPC_ARGS} TC )
  endif()
  if (PRECOMPILE_GEMM_TRANS_CN)
    set(AGPC_ARGS ${AGPC_ARGS} CN )
  endif()
  if (PRECOMPILE_GEMM_TRANS_CT)
    set(AGPC_ARGS ${AGPC_ARGS} CT )
  endif()
  if (PRECOMPILE_GEMM_TRANS_CC)
    set(AGPC_ARGS ${AGPC_ARGS} CC )
  endif()

  # betas
  set(AGPC_ARGS ${AGPC_ARGS} --betas 0 1 )



################################################################################
# add target for generating pre-compile WhichKernels header
################################################################################
set( AUTOGEMM_PRECOMPILE_HEADER_SRC ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/KernelsToPreCompile.py )
set( AUTOGEMM_PRECOMPILE_HEADER_OUT ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelsToPreCompile.h )
add_custom_command(
  OUTPUT ${AUTOGEMM_PRECOMPILE_HEADER_OUT}
  COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/KernelsToPreCompile.py ${AGPC_ARGS}
  DEPENDS ${AUTOGEMM_PRECOMPILE_HEADER_SRC}
)

################################################################################
# add target for compiling pre-compile executable
################################################################################
add_executable(AutoGemm_PreCompile_Bin
  ${AUTOGEMM_PRECOMPILE_SRC}
  ${AUTOGEMM_PRECOMPILE_HEADER_OUT}
  ${AUTOGEMM_HEADERS}
  ${AUTOGEMM_SRC}
  ${AUTOGEMM_SCRIPTS}
  )
target_link_libraries(AutoGemm_PreCompile_Bin ${OPENCL_LIBRARIES})
set_property( TARGET AutoGemm_PreCompile_Bin PROPERTY FOLDER "AutoGemm")
#set_target_properties(
  #AutoGemm_PreCompile_Bin
  #PROPERTIES
  #EXCLUDE_FROM_ALL TRUE
  #EXCLUDE_FROM_DEFAULT_BUILD TRUE
#)


################################################################################
# add target for running pre-compile executable
################################################################################
add_custom_command(
  OUTPUT ${AUTOGEMM_PRECOMPILED_KERNELS}
  COMMAND AutoGemm_PreCompile_Bin ${CMAKE_BINARY_DIR}
  DEPENDS AutoGemm_PreCompile_Bin
)

endif()#endif precompile active


################################################################################
# add target for main AutoGemm headers / source
################################################################################
add_custom_command(
  OUTPUT ${AUTOGEMM_HEADERS} ${AUTOGEMM_SRC}
  COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/AutoGemm.py --output-path ${CMAKE_BINARY_DIR}/include --opencl-compiler-version ${OPENCL_VERSION} --architecture ${AUTOGEMM_ARCHITECTURE}
  DEPENDS ${AUTOGEMM_SCRIPTS}
)


include_directories(
    ${OPENCL_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}/include
    .
)

################################################################################
# AutoGemm Tools
################################################################################
add_executable(AutoGemm_Tools_Test
  ${AUTOGEMM_TEST_SRC}
  ${AUTOGEMM_SRC}
  ${AUTOGEMM_HEADERS}
  ${AUTOGEMM_SCRIPTS}
  )
target_link_libraries(AutoGemm_Tools_Test ${OPENCL_LIBRARIES})
set_property( TARGET AutoGemm_Tools_Test PROPERTY FOLDER "AutoGemm")
set_target_properties(
  AutoGemm_Tools_Test
  PROPERTIES
  EXCLUDE_FROM_ALL TRUE
  EXCLUDE_FROM_DEFAULT_BUILD TRUE
)


add_executable(AutoGemm_Tools_Profile
  ${AUTOGEMM_PROFILER_SRC}
  ${AUTOGEMM_SRC}
  ${AUTOGEMM_HEADERS}
  ${AUTOGEMM_SCRIPTS}
  )
target_link_libraries(AutoGemm_Tools_Profile ${OPENCL_LIBRARIES})
set_property( TARGET AutoGemm_Tools_Profile PROPERTY FOLDER "AutoGemm")
set_target_properties(
  AutoGemm_Tools_Profile
  PROPERTIES
  EXCLUDE_FROM_ALL TRUE
  EXCLUDE_FROM_DEFAULT_BUILD TRUE
)

source_group(AutoGemm\\scripts FILES ${AUTOGEMM_SCRIPTS} )
source_group(AutoGemm\\include FILES ${AUTOGEMM_HEADERS} )
source_group(AutoGemm\\src FILES ${AUTOGEMM_SRC} ${AUTOGEMM_PRECOMPILED_KERNELS} )

################################################################################
# AutoGemm End
################################################################################

################################################################################
# BEGIN Pre Compile General (static) Kernels
################################################################################
# options for pre-compiling trsm kernels
option( PRECOMPILE_TRSM_STRSM "pre-compile available dtrsm kernels" OFF )
option( PRECOMPILE_TRSM_DTRSM "pre-compile available strsm kernels" OFF )
if(PRECOMPILE_TRSM_DTRSM)

=== src/samples/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

set(SGEMV_SAMPLE_SRC example_sgemv.c)
set(SSYMV_SAMPLE_SRC example_ssymv.c)
set(SGEMM_SAMPLE_SRC example_sgemm.c)
set(STRMM_SAMPLE_SRC example_strmm.c)
set(STRSM_SAMPLE_SRC example_strsm.c)
set(STRSM_SAMPLE_SRCPP example_strsm.cpp)
set(CTRSM_SAMPLE_SRC example_ctrsm.c)
set(SSYRK_SAMPLE_SRC example_ssyrk.c)
set(SSYR2K_SAMPLE_SRC example_ssyr2k.c)

set(STRMV_SAMPLE_SRC example_strmv.c) # Addition: for STRMV
set(DTRMV_SAMPLE_SRC example_dtrmv.c) # Addition: for STRMV
set(STRSV_SAMPLE_SRC example_strsv.c) # Addition: for STRSV
set(SGER_SAMPLE_SRC example_sger.c)   # Addition: for SGER
set(SSYR_SAMPLE_SRC example_ssyr.c)   # Addition: for SSYR
set(SSYR2_SAMPLE_SRC example_ssyr2.c)   # Addition: for SSYR2
set(CHER_SAMPLE_SRC example_cher.c)
set(ZHEMV_SAMPLE_SRC example_zhemv.cpp)
set(ZHER2_SAMPLE_SRC example_zher2.c)
set(CHERK_SAMPLE_SRC example_cherk.cpp)
set(SSYMM_SAMPLE_SRC example_ssymm.c)
set(CHEMM_SAMPLE_SRC example_chemm.cpp)

set(STPMV_SAMPLE_SRC example_stpmv.c)
set(CHPMV_SAMPLE_SRC example_chpmv.c)
set(STPSV_SAMPLE_SRC example_stpsv.c)
set(SSPMV_SAMPLE_SRC example_sspmv.c)
set(SSPR_SAMPLE_SRC example_sspr.c)
set(CHPR_SAMPLE_SRC example_chpr.c)
set(SSPR2_SAMPLE_SRC example_sspr2.c)
set(ZHPR2_SAMPLE_SRC example_zhpr2.c)

set(SGBMV_SAMPLE_SRC example_sgbmv.c)
set(STBMV_SAMPLE_SRC example_stbmv.c)
set(SSBMV_SAMPLE_SRC example_ssbmv.c)
set(CHBMV_SAMPLE_SRC example_chbmv.c)
set(STBSV_SAMPLE_SRC example_stbsv.c)

set(CHER2K_SAMPLE_SRC example_cher2k.c)

set(SSWAP_SAMPLE_SRC example_sswap.c)
set(SSCAL_SAMPLE_SRC example_sscal.c)
set(CSSCAL_SAMPLE_SRC example_csscal.c)
set(SCOPY_SAMPLE_SRC example_scopy.c)
set(SAXPY_SAMPLE_SRC example_saxpy.c)
set(SDOT_SAMPLE_SRC example_sdot.c)

set(SROTG_SAMPLE_SRC example_srotg.c)
set(SROTMG_SAMPLE_SRC example_srotmg.c)
set(SROT_SAMPLE_SRC example_srot.c)
set(SROTM_SAMPLE_SRC example_srotm.c)
set(iSAMAX_SAMPLE_SRC example_isamax.c)
set(SNRM2_SAMPLE_SRC example_snrm2.c)
set(SASUM_SAMPLE_SRC example_sasum.c)

set(VERSION_SAMPLE_SRC clBlasVersion.c)

include_directories(${OPENCL_INCLUDE_DIRS} ${clBLAS_SOURCE_DIR})

add_executable(example_sgemv ${SGEMV_SAMPLE_SRC})
target_link_libraries(example_sgemv ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_sgemv PROPERTY FOLDER "Samples")

add_executable(example_ssymv ${SSYMV_SAMPLE_SRC})
target_link_libraries(example_ssymv ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_ssymv PROPERTY FOLDER "Samples")

add_executable(example_sgemm ${SGEMM_SAMPLE_SRC})
target_link_libraries(example_sgemm ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_sgemm PROPERTY FOLDER "Samples")

add_executable(example_strmm ${STRMM_SAMPLE_SRC})
target_link_libraries(example_strmm ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_strmm PROPERTY FOLDER "Samples")

add_executable(example_strsm ${STRSM_SAMPLE_SRC})
target_link_libraries(example_strsm ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_strsm PROPERTY FOLDER "Samples")

add_executable(example_strsm_cpp ${STRSM_SAMPLE_SRCPP})
target_link_libraries(example_strsm_cpp ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_strsm_cpp PROPERTY FOLDER "Samples")

add_executable(example_ctrsm ${CTRSM_SAMPLE_SRC})
target_link_libraries(example_ctrsm ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_ctrsm PROPERTY FOLDER "Samples")

add_executable(example_ssyrk ${SSYRK_SAMPLE_SRC})
target_link_libraries(example_ssyrk ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_ssyrk PROPERTY FOLDER "Samples")

add_executable(example_ssyr2k ${SSYR2K_SAMPLE_SRC})
target_link_libraries(example_ssyr2k ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_ssyr2k PROPERTY FOLDER "Samples")

add_executable(version ${VERSION_SAMPLE_SRC})
target_link_libraries(version ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET version PROPERTY FOLDER "Samples")

# Addition - for samples
add_executable(example_strmv ${STRMV_SAMPLE_SRC})
target_link_libraries(example_strmv ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_strmv PROPERTY FOLDER "Samples")

add_executable(example_dtrmv ${DTRMV_SAMPLE_SRC})
target_link_libraries(example_dtrmv ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_dtrmv PROPERTY FOLDER "Samples")

add_executable(example_strsv ${STRSV_SAMPLE_SRC})
target_link_libraries(example_strsv ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_strsv PROPERTY FOLDER "Samples")

add_executable(example_sger ${SGER_SAMPLE_SRC})
target_link_libraries(example_sger ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_sger PROPERTY FOLDER "Samples")

add_executable(example_cher ${CHER_SAMPLE_SRC})
target_link_libraries(example_cher ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_cher PROPERTY FOLDER "Samples")

add_executable(example_ssyr ${SSYR_SAMPLE_SRC})
target_link_libraries(example_ssyr ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_ssyr PROPERTY FOLDER "Samples")

add_executable(example_ssyr2 ${SSYR2_SAMPLE_SRC})
target_link_libraries(example_ssyr2 ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_ssyr2 PROPERTY FOLDER "Samples")

add_executable(example_zhemv ${ZHEMV_SAMPLE_SRC})
target_link_libraries(example_zhemv ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_zhemv PROPERTY FOLDER "Samples")

add_executable(example_zher2 ${ZHER2_SAMPLE_SRC})
target_link_libraries(example_zher2 ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_zher2 PROPERTY FOLDER "Samples")

add_executable(example_cherk ${CHERK_SAMPLE_SRC})
target_link_libraries(example_cherk ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_cherk PROPERTY FOLDER "Samples")

add_executable(example_ssymm ${SSYMM_SAMPLE_SRC})
target_link_libraries(example_ssymm ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_ssymm PROPERTY FOLDER "Samples")

add_executable(example_chemm ${CHEMM_SAMPLE_SRC})
target_link_libraries(example_chemm ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_chemm PROPERTY FOLDER "Samples")

add_executable(example_stpmv ${STPMV_SAMPLE_SRC})
target_link_libraries(example_stpmv ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_stpmv PROPERTY FOLDER "Samples")

add_executable(example_chpmv ${CHPMV_SAMPLE_SRC})
target_link_libraries(example_chpmv ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_chpmv PROPERTY FOLDER "Samples")

add_executable(example_stpsv ${STPSV_SAMPLE_SRC})
target_link_libraries(example_stpsv ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_stpsv PROPERTY FOLDER "Samples")

add_executable(example_sspmv ${SSPMV_SAMPLE_SRC})
target_link_libraries(example_sspmv ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_sspmv PROPERTY FOLDER "Samples")

add_executable(example_sspr ${SSPR_SAMPLE_SRC})
target_link_libraries(example_sspr ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_sspr PROPERTY FOLDER "Samples")

add_executable(example_chpr ${CHPR_SAMPLE_SRC})
target_link_libraries(example_chpr ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_chpr PROPERTY FOLDER "Samples")

add_executable(example_sspr2 ${SSPR2_SAMPLE_SRC})
target_link_libraries(example_sspr2 ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_sspr2 PROPERTY FOLDER "Samples")

add_executable(example_zhpr2 ${ZHPR2_SAMPLE_SRC})
target_link_libraries(example_zhpr2 ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_zhpr2 PROPERTY FOLDER "Samples")

add_executable(example_sgbmv ${SGBMV_SAMPLE_SRC})
target_link_libraries(example_sgbmv ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_sgbmv PROPERTY FOLDER "Samples")

add_executable(example_stbmv ${STBMV_SAMPLE_SRC})
target_link_libraries(example_stbmv ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_stbmv PROPERTY FOLDER "Samples")

add_executable(example_ssbmv ${SSBMV_SAMPLE_SRC})
target_link_libraries(example_ssbmv ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_ssbmv PROPERTY FOLDER "Samples")

add_executable(example_chbmv ${CHBMV_SAMPLE_SRC})
target_link_libraries(example_chbmv ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_chbmv PROPERTY FOLDER "Samples")

add_executable(example_stbsv ${STBSV_SAMPLE_SRC})
target_link_libraries(example_stbsv ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_stbsv PROPERTY FOLDER "Samples")

add_executable(example_cher2k ${CHER2K_SAMPLE_SRC})
target_link_libraries(example_cher2k ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_cher2k PROPERTY FOLDER "Samples")

add_executable(example_sswap ${SSWAP_SAMPLE_SRC})
target_link_libraries(example_sswap ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_sswap PROPERTY FOLDER "Samples")

add_executable(example_sscal ${SSCAL_SAMPLE_SRC})
target_link_libraries(example_sscal ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_sscal PROPERTY FOLDER "Samples")

add_executable(example_csscal ${CSSCAL_SAMPLE_SRC})
target_link_libraries(example_csscal ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_csscal PROPERTY FOLDER "Samples")

add_executable(example_scopy ${SCOPY_SAMPLE_SRC})
target_link_libraries(example_scopy ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_scopy PROPERTY FOLDER "Samples")

add_executable(example_saxpy ${SAXPY_SAMPLE_SRC})
target_link_libraries(example_saxpy ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_saxpy PROPERTY FOLDER "Samples")

add_executable(example_sdot ${SDOT_SAMPLE_SRC})
target_link_libraries(example_sdot ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_sdot PROPERTY FOLDER "Samples")

add_executable(example_srotg ${SROTG_SAMPLE_SRC})
target_link_libraries(example_srotg ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_srotg PROPERTY FOLDER "Samples")

add_executable(example_srotmg ${SROTMG_SAMPLE_SRC})
target_link_libraries(example_srotmg ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_srotmg PROPERTY FOLDER "Samples")

add_executable(example_srot ${SROT_SAMPLE_SRC})
target_link_libraries(example_srot ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_srot PROPERTY FOLDER "Samples")

add_executable(example_srotm ${SROTM_SAMPLE_SRC})
target_link_libraries(example_srotm ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_srotm PROPERTY FOLDER "Samples")

add_executable(example_isamax ${iSAMAX_SAMPLE_SRC})
target_link_libraries(example_isamax ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_isamax PROPERTY FOLDER "Samples")

add_executable(example_snrm2 ${SNRM2_SAMPLE_SRC})
target_link_libraries(example_snrm2 ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_snrm2 PROPERTY FOLDER "Samples")

add_executable(example_sasum ${SASUM_SAMPLE_SRC})
target_link_libraries(example_sasum ${OPENCL_LIBRARIES} clBLAS)
set_property( TARGET example_sasum PROPERTY FOLDER "Samples")

# CPack configuration; include the executable into the package
if( WIN32 )
    set( CLBLAS_EXAMPLE_INSTALL_DESTINATION bin${SUFFIX_BIN})
else( )
    set( CLBLAS_EXAMPLE_INSTALL_DESTINATION share/clBLAS/samples)
endif()
install( TARGETS example_sgemm example_sgemv example_ssymv example_ssyrk
         example_ssyr2k example_strmm example_strsm
         example_strmv example_strsv example_sger example_cher example_ssyr
         example_ssyr2 example_cherk example_ssymm example_chemm

=== src/tests/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

set(SRC_COMMON
    cmdline.c
    common.cpp
    clBLAS-wrapper.cpp
    BlasBase.cpp
)

set(SRC_COMMON_TIMER
    timer.c
)

# group of sources with reference implementation stuff
set (SRC_COMMON_REFIMPL
    blas.c
    blas-cblas.c
    blas-wrapper.cpp
)

set(SRC_CORR
    correctness/blas-lapack.c
    correctness/BlasBase-corr.cpp
    correctness/corr-gemm.cpp
    correctness/corr-trmm.cpp
    correctness/corr-trsm.cpp
    correctness/corr-gemv.cpp
    correctness/corr-symv.cpp
    correctness/corr-spmv.cpp
    correctness/corr-syr2k.cpp
    correctness/corr-syrk.cpp
    correctness/corr-trmv.cpp
    correctness/corr-tpmv.cpp
    correctness/corr-trsv.cpp
	correctness/corr-symm.cpp
	correctness/corr-gemm2.cpp
	correctness/corr-ger.cpp
	correctness/corr-gerc.cpp
    correctness/corr-her.cpp
	correctness/corr-her2.cpp
	correctness/corr-syr.cpp
    correctness/corr-spr.cpp
	correctness/corr-syr2.cpp
	correctness/corr-hemv.cpp
	correctness/corr-hpmv.cpp
	correctness/corr-hemm.cpp
	correctness/corr-herk.cpp
    correctness/corr-tpsv.cpp
    correctness/corr-hpr.cpp
	correctness/corr-hpr2.cpp
	correctness/corr-spr2.cpp
	correctness/corr-gbmv.cpp
    correctness/corr-hbmv.cpp
	correctness/corr-tbmv.cpp
    correctness/corr-tbsv.cpp
    correctness/corr-sbmv.cpp
    correctness/corr-her2k.cpp
    correctness/corr-scal.cpp
	correctness/corr-swap.cpp
	correctness/corr-copy.cpp
    correctness/corr-axpy.cpp
	correctness/corr-dot.cpp
    correctness/corr-dotc.cpp
    correctness/corr-rotg.cpp
    correctness/corr-rotm.cpp
	correctness/corr-rot.cpp
    correctness/corr-rotmg.cpp
    correctness/corr-nrm2.cpp
    correctness/corr-asum.cpp
    correctness/corr-iamax.cpp
    correctness/test-correctness.cpp
    correctness/tcase-filter.cpp
)

set(SRC_PERF
    performance/PerformanceRecorder.cpp
    performance/PerformanceTest.cpp
    performance/TrxmPerformanceTest.cpp
    performance/BlasBase-perf.cpp
    performance/perf-gemm.cpp
    performance/perf-gemm2.cpp
    performance/perf-gemv.cpp
    performance/perf-syr2k.cpp
    performance/perf-syrk.cpp
    performance/perf-symv.cpp
    performance/perf-spmv.cpp
    performance/perf-trmm.cpp
    performance/perf-trsm.cpp
    performance/perf-trmv.cpp
    performance/perf-tpmv.cpp
    performance/perf-trsv.cpp
    performance/perf-symm.cpp
    performance/perf-ger.cpp
    performance/perf-gerc.cpp
    performance/perf-syr.cpp
    performance/perf-spr.cpp
	performance/perf-her.cpp
	performance/perf-her2.cpp
    performance/perf-syr2.cpp
	performance/perf-hemm.cpp
    performance/perf-hemv.cpp
    performance/perf-hpmv.cpp
    performance/perf-herk.cpp
	performance/perf-tpsv.cpp
    performance/perf-hpr.cpp
	performance/perf-hpr2.cpp
    performance/perf-spr2.cpp
    performance/perf-sbmv.cpp
    performance/perf-gbmv.cpp
    performance/perf-hbmv.cpp
    performance/perf-tbmv.cpp
    performance/perf-tbsv.cpp
    performance/perf-her2k.cpp
    performance/perf-scal.cpp
    performance/perf-swap.cpp
	performance/perf-copy.cpp
    performance/perf-axpy.cpp
	performance/perf-dot.cpp
    performance/perf-dotc.cpp
    performance/perf-rotg.cpp
    performance/perf-rotm.cpp
	performance/perf-rot.cpp
    performance/perf-rotmg.cpp
    performance/perf-nrm2.cpp
    performance/perf-asum.cpp
    performance/perf-iamax.cpp
	performance/test-performance.cpp
)

set(SRC_FUNC
   functional/func-error.cpp
   functional/func-event.cpp
   functional/func-thread.cpp
   functional/func-queue.cpp
   #functional/func-images.cpp
   functional/test-functional.cpp
   functional/BlasBase-func.cpp
)

set(TESTS_HEADERS
    ${clBLAS_SOURCE_DIR}/clBLAS.h
    ${clBLAS_SOURCE_DIR}/clBLAS-complex.h
	${clBLAS_SOURCE_DIR}/include/cltypes.h
	${clBLAS_SOURCE_DIR}/include/defbool.h
    include/blas-internal.h
    include/blas-cblas.h
    include/blas-wrapper.h
    include/clBLAS-wrapper.h
    include/cmdline.h
    include/BlasBase.h
    include/common.h
    include/BlasBase.h
    include/gemm.h
    include/trmm.h
    include/tpmv.h
    include/trsm.h
    include/gemv.h
    include/symv.h
    include/spmv.h
    include/syr2k.h
    include/syrk.h
    include/trmv.h
    include/trsv.h
	include/symm.h
	include/ger.h
    include/gerc.h
    include/syr.h
    include/spr.h
    include/her.h
	include/her2.h
    include/syr2.h
	include/hemv.h
	include/hpmv.h
	include/hemm.h
	include/herk.h
    include/tpsv.h
    include/hpr.h
	include/hpr2.h
    include/spr2.h
    include/gbmv.h
    include/hbmv.h
    include/tbmv.h
    include/tbsv.h
	include/copy.h
    include/sbmv.h
    include/dot.h
    include/dotc.h
    include/her2k.h
    include/scal.h
	include/swap.h
    include/axpy.h
    include/rotg.h
    include/rotm.h
	include/rot.h
    include/asum.h
    include/rotmg.h
    include/nrm2.h
    include/iamax.h
	include/blas-math.h
    include/blas-random.h
    include/matrix.h
    include/timer.h
)

set(CORR_HEADERS
    correctness/blas-lapack.h
    correctness/trsm-delta.h
    correctness/tcase-filter.h
    correctness/delta.h
	correctness/trsv-delta.h
)

set(PERF_HEADERS
    performance/PerformanceTest.h
    performance/PerformanceRecorder.h
)

set(FUNC_HEADERS
   functional/func.h
)

# Setup Visual Studio file tabs
source_group(correctness FILES ${SRC_CORR} ${CORR_HEADERS})
source_group(performance FILES ${SRC_PERF} ${PERF_HEADERS})
source_group(functional  FILES ${SRC_FUNC} ${FUNC_HEADERS})

# FIXME: it's a temporary solution to workaround segfault in clGetProgramInfo()
# at paramVal = CL_PROGRAM_BINARIES and several devices in the context
add_definitions( -DTEST_WITH_SINGLE_DEVICE )

# vs11 needs std::tuples compiled with 10 parameters by default
# NOTE: this assumes that googletest is compiled with the same preprocessor macro; they must match
if( MSVC11 )
	add_definitions( "/D_VARIADIC_MAX=10" )
endif()

# Having problems on build server, compiling gtest headers with -pedantic; disabling detection of long long
# http://code.google.com/p/googletest/issues/detail?id=334
if( CMAKE_COMPILER_IS_GNUCXX )
	add_definitions( -Wno-long-long -Wno-variadic-macros )
endif( )

if( CMAKE_Fortran_COMPILER_ID STREQUAL "PGI" )
	message( STATUS "Detected PGI Fortran compiler." )

	# By default, -Mipa=fast is used, and this does not mix well with the cl compiler
	string( REPLACE "-Mipa=fast" "" CMAKE_Fortran_FLAGS_RELEASE ${CMAKE_Fortran_FLAGS_RELEASE} )

	# In windows, dynamically link to the C runtime, and tell fortran linker to not include default main subroutine
	if( WIN32 )
		set( CMAKE_EXE_LINKER_FLAGS "-Bdynamic -Mnostartup ${CMAKE_EXE_LINKER_FLAGS}" )
	endif( )
endif( )

# Library with functions for time measurement. In Windows they are included automatically
if(UNIX)
    if(NOT APPLE)
        set(TIME_LIBRARY "rt")
    endif()
    set(THREAD_LIBRARY "pthread")
endif()

# This logic supports the build server, if it compiles the runtime seperately from the test programs
# It stitches together a path to a previously built static library, based on our 'make install' logic
# Search for 64bit libs if FIND_LIBRARY_USE_LIB64_PATHS is set to true in the global environment, 32bit libs else
get_property( LIB64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS )
set( runtime.library "${CMAKE_INSTALL_PREFIX}/lib${SUFFIX_LIB}" )

if( WIN32 )
	set( runtime.library "${runtime.library}/import/clBLAS${CMAKE_STATIC_LIBRARY_SUFFIX}" )
else( )
	set( runtime.library "${runtime.library}/${CMAKE_SHARED_LIBRARY_PREFIX}clBLAS${CMAKE_SHARED_LIBRARY_SUFFIX}" )
endif( )

# Find Google Test package
include(gtest.cmake)

if( GTEST_FOUND )
    if( CORR_TEST_WITH_ACML AND ACML_FOUND )
		include_directories(${OPENCL_INCLUDE_DIRS} ${GTEST_INCLUDE_DIRS}
			${clBLAS_SOURCE_DIR} ${ACML_INCLUDE_DIRS}
			${clBLAS_SOURCE_DIR}/tests/include  ${clBLAS_SOURCE_DIR}/include)

		add_definitions(-DCORR_TEST_WITH_ACML)

	    add_executable(test-correctness ${SRC_CORR} ${SRC_COMMON} ${SRC_COMMON_REFIMPL}
									    ${CORR_HEADERS} ${TESTS_HEADERS})
        set_target_properties( test-correctness PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

	    add_executable(test-medium ${SRC_CORR} ${SRC_COMMON} ${SRC_COMMON_REFIMPL}
							      ${CORR_HEADERS} ${TESTS_HEADERS})
	    set_target_properties(test-medium PROPERTIES COMPILE_DEFINITIONS MEDIUM_TESTS)
        set_target_properties( test-medium PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

	    add_executable(test-short ${SRC_CORR} ${SRC_COMMON} ${SRC_COMMON_REFIMPL}
							      ${CORR_HEADERS} ${TESTS_HEADERS})
	    set_target_properties(test-short PROPERTIES COMPILE_DEFINITIONS SHORT_TESTS)
        set_target_properties( test-short PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

	    # The build server builds the library with gcc 4.1.2 to support Red Hat 5.5, but the test programs must be built with
	    # gcc > 4.3.2 to support ACML.
	    # If the runtime is being built by the project, use it, otherwise link to a runtime library specified in the install prefix
	    if( BUILD_RUNTIME )
		    target_link_libraries(test-correctness ${ACML_LIBRARIES} ${GTEST_LIBRARIES} ${THREAD_LIBRARY} clBLAS)
		    target_link_libraries(test-medium ${ACML_LIBRARIES} ${GTEST_LIBRARIES} ${THREAD_LIBRARY} clBLAS)
		    target_link_libraries(test-short ${ACML_LIBRARIES} ${GTEST_LIBRARIES} ${THREAD_LIBRARY} clBLAS)
	    else( )
		    target_link_libraries(test-correctness
			    ${ACML_LIBRARIES} ${GTEST_LIBRARIES} ${OPENCL_LIBRARIES} ${THREAD_LIBRARY} ${runtime.library})
		    target_link_libraries(test-medium
			    ${ACML_LIBRARIES} ${GTEST_LIBRARIES} ${OPENCL_LIBRARIES} ${THREAD_LIBRARY} ${runtime.library})
		    target_link_libraries(test-short
			    ${ACML_LIBRARIES} ${GTEST_LIBRARIES} ${OPENCL_LIBRARIES} ${THREAD_LIBRARY}  ${runtime.library})
	    endif( )
	else( )
		#Link against the netlib reference library
		include_directories(${OPENCL_INCLUDE_DIRS} ${GTEST_INCLUDE_DIRS}
			${clBLAS_SOURCE_DIR} ${clBLAS_SOURCE_DIR}/tests/include ${clBLAS_SOURCE_DIR}/include})

		add_executable(test-correctness ${SRC_CORR} ${SRC_COMMON} ${SRC_COMMON_REFIMPL}
						${CORR_HEADERS} ${TESTS_HEADERS})
        set_target_properties( test-correctness PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

		add_executable(test-medium ${SRC_CORR} ${SRC_COMMON} ${SRC_COMMON_REFIMPL}
					  ${CORR_HEADERS} ${TESTS_HEADERS})
		set_target_properties( test-medium PROPERTIES COMPILE_DEFINITIONS MEDIUM_TESTS )
        set_target_properties( test-medium PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

		add_executable(test-short ${SRC_CORR} ${SRC_COMMON} ${SRC_COMMON_REFIMPL}
					  ${CORR_HEADERS} ${TESTS_HEADERS})
		set_target_properties( test-short PROPERTIES COMPILE_DEFINITIONS SHORT_TESTS )
        set_target_properties( test-short PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

		if( NOT CORR_TEST_WITH_ACML AND NOT WIN32 AND NOT APPLE)
			set_target_properties( test-correctness PROPERTIES LINKER_LANGUAGE Fortran )
			set_target_properties( test-medium PROPERTIES LINKER_LANGUAGE Fortran )
			set_target_properties( test-short PROPERTIES LINKER_LANGUAGE Fortran )
		endif( )

	    if( BUILD_RUNTIME )
			if( NETLIB_FOUND )

=== src/scripts/perf/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

set(GRAPHING_SCRIPTS 	measurePerformance.py 
						plotPerformance.py 
						blasPerformanceTesting.py 
						errorHandler.py 
						performanceUtility.py
						)

if( WIN32 )
		install( FILES ${GRAPHING_SCRIPTS} DESTINATION bin${SUFFIX_BIN} )
else ( )
		install( FILES ${GRAPHING_SCRIPTS} DESTINATION share/clBLAS )
endif( )

=== src/library/common/tests/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

set(SRC_COMMON
    ../list.c
    ../clkern.c
    ../kern_cache.c
    ../kerngen_core.c
    ../kgen_basic.c
    ../kgen_loop_helper.c
    ../kgen_guard.c
    ../misc.c
    ../gens/dblock_kgen.c
    ../devinfo.c
    ../devinfo-cache.c
    ../mutex.c
    ../trace_malloc.c
)

set(SRC_DBLOCK_KGEN
    ${SRC_COMMON}
    t_dblock_kgen.c
)

set(SRC_GENS_CACHE
    ${SRC_COMMON}
    t_gens_cache.c
)

include_directories(${OPENCL_INCLUDE_DIRS} ${clBLAS_SOURCE_DIR} ${clBLAS_SOURCE_DIR}/include ${clBLAS_SOURCE_DIR}/src/blas/include)

add_executable(t_dblock_kgen ${SRC_DBLOCK_KGEN})
target_link_libraries(t_dblock_kgen ${OPENCL_LIBRARIES} ${MATH_LIBRARY})
set_target_properties( t_dblock_kgen PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

add_executable(t_gens_cache ${SRC_GENS_CACHE})
target_link_libraries(t_gens_cache ${OPENCL_LIBRARIES} ${MATH_LIBRARY})
set_target_properties( t_gens_cache PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

# CPack configuration; include the executable into the package
install( TARGETS t_dblock_kgen t_gens_cache
		RUNTIME DESTINATION bin${SUFFIX_BIN}
		LIBRARY DESTINATION lib${SUFFIX_LIB}
		ARCHIVE DESTINATION lib${SUFFIX_LIB}/import
		)

=== src/library/tools/OCLBinaryGenerator/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

cmake_minimum_required(VERSION 2.6)
project(OCLBinaryGenerator C CXX)
ADD_DEFINITIONS(/D_CRT_SECURE_NO_WARNINGS)
ADD_EXECUTABLE(OCLBinaryGenerator OCLBinaryGenerator.cpp)
target_link_libraries(OCLBinaryGenerator ${OPENCL_LIBRARIES})
include_directories(${OPENCL_INCLUDE_DIRS})

set_target_properties( OCLBinaryGenerator PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/staging" )
  
if ( MSVC )
  set_target_properties( OCLBinaryGenerator PROPERTIES RUNTIME_OUTPUT_DIRECTORY_DEBUG "${CMAKE_CURRENT_BINARY_DIR}/staging" )
  set_target_properties( OCLBinaryGenerator PROPERTIES RUNTIME_OUTPUT_DIRECTORY_RELEASE "${CMAKE_CURRENT_BINARY_DIR}/staging" )
endif( )

=== src/library/tools/bingen/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

cmake_minimum_required(VERSION 2.6)
project(bingen C CXX)
ADD_DEFINITIONS(/D_CRT_SECURE_NO_WARNINGS)
ADD_EXECUTABLE(bingen bingen.cpp)
target_link_libraries(bingen ${OPENCL_LIBRARIES})
include_directories(${OPENCL_INCLUDE_DIRS})

set_target_properties( bingen PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/staging" )
  
if ( MSVC )
  set_target_properties( bingen PROPERTIES RUNTIME_OUTPUT_DIRECTORY_DEBUG "${CMAKE_CURRENT_BINARY_DIR}/staging" )
  set_target_properties( bingen PROPERTIES RUNTIME_OUTPUT_DIRECTORY_RELEASE "${CMAKE_CURRENT_BINARY_DIR}/staging" )
endif( )

=== src/library/tools/tune/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

set(TOOLS_SRC
    tune.c
    toolslib.c
    fileio.c
    subdim.c
    storage_data.c
    storage_init.c
    storage_io.c
    dimension.c
)

set(TOOLS_EXTERNAL_SRC
    ../../blas/generic/common.c
    ../../blas/generic/common2.cc
    ../../blas/generic/blas_funcs.c
    ../../blas/init.c
    ../../blas/impl.c
    ../../blas/scimage.c
    ../../blas/generic/events.c
    ../../blas/generic/matrix_props.c
    ../../blas/generic/matrix_dims.c
    ../../blas/gens/tile.c
    ../../blas/gens/tile_iter.c
    ../../blas/gens/blas_subgroup.c
    ../../blas/gens/decomposition.c
    ../../blas/gens/blas_subgroup.c
    ../../blas/gens/blas_kgen.c
    ../../blas/gens/gen_helper.c
    ../../blas/gens/tilemul.c
    ../../blas/gens/fetch.c
    ../../blas/gens/gen_init.c
    ../../blas/gens/gemv.c
    ../../blas/gens/symv.c
    ../../blas/gens/gemm.c
    ../../blas/gens/trmm.c
    ../../blas/gens/trsm.c
    ../../blas/gens/syrxk.c
    ../../blas/gens/trxm_common.c
    ../../blas/gens/trsm_kgen.c
    ../../blas/gens/xxmv_common.c
    ../../blas/gens/legacy/blas_kgen_legacy.c
    ../../blas/gens/legacy/gen_helper_legacy.c
    ../../blas/gens/legacy/trxm_common_legacy.c
    ../../blas/gens/legacy/trsm_kgen_legacy.c
    ../../blas/gens/legacy/blkmul.c
    ../../blas/gens/legacy/gemm_lds.c
    ../../blas/gens/legacy/gemm_img.c
    ../../blas/gens/legacy/trmm_lds.c
    ../../blas/gens/legacy/trmm_img.c
    ../../blas/gens/legacy/trsm_lds.c
    ../../blas/gens/legacy/trsm_img.c
    ../../blas/gens/legacy/trsm_cached_lds.c
    ../../common/devinfo.c
    ../../common/kern_cache.c
    ../../common/mutex.c
    ../../common/list.c
    ../../common/kerngen_core.c
    ../../common/kgen_basic.c
    ../../common/kgen_loop_helper.c
    ../../common/misc.c
    ../../common/kgen_guard.c
    ../../common/clkern.c
    ../../common/trace_malloc.c
    ../../common/md5sum.c
    ../../common/gens/dblock_kgen.c
    ../../blas/generic/solution_seq_make.c
    ../../blas/generic/solution_seq.c
    ../../blas/generic/solution_assert.c
    ../../blas/generic/problem_iter.c
    ../../blas/generic/kernel_extra.c
    ../../blas/generic/kdump.c
    ../../blas/generic/binary_lookup.cc
    ../../blas/generic/functor_cache.cc
    ../../blas/gens/trmv_reg.cpp
    ../../blas/gens/ger_lds.cpp
    ../../blas/gens/trsv_trtri.cpp
    ../../blas/gens/trsv_gemv.cpp
    ../../blas/gens/kprintf.cpp
    ../../blas/gens/syr_lds.cpp
    ../../blas/gens/symm_cached.cpp
    ../../blas/gens/gemm_cached.cpp
    ../../blas/gens/gemm_tail_cached.cpp
    ../../blas/gens/syr2_lds.cpp
    ../../blas/gens/her_lds.cpp
    ../../blas/gens/her2_lds.cpp
    ../../blas/gens/gbmv.cpp
    ../../blas/gens/tuned_numbers.c
    ../../blas/gens/swap_reg.cpp
    ../../blas/gens/scal_reg.cpp
    ../../blas/gens/copy_reg.cpp
    ../../blas/gens/axpy_reg.cpp
    ../../blas/gens/dot.cpp
    ../../blas/gens/reduction.cpp
    ../../blas/gens/rotg_reg.cpp
    ../../blas/gens/rotmg_reg.cpp
    ../../blas/gens/rotm_reg.cpp
    ../../blas/gens/iamax.cpp
    ../../blas/gens/nrm2.cpp
    ../../blas/gens/asum.cpp
)

include_directories(${OPENCL_INCLUDE_DIRS}
    ${clBLAS_SOURCE_DIR}
    ${clBLAS_SOURCE_DIR}/include
    ${clBLAS_SOURCE_DIR}/library/blas/include
    ${clBLAS_SOURCE_DIR}/library/blas/gens
    ${clBLAS_BINARY_DIR}/include
    ${clBLAS_SOURCE_DIR}/library/tools/tune
)

#setup Visual studio tabs
source_group(\\ FILES ${TOOLS_SRC})

option( BLAS_DEBUG_TOOLS "Compile extra debug logic with regards to tuning database" OFF )
if( BLAS_DEBUG_TOOLS )
    add_definitions( -D_DEBUG_TOOLS )
endif()

# Library with functions for time measurement. In Windows they are included automatically
if(UNIX AND NOT APPLE)
    set(TIME_LIBRARY "rt")
endif()


add_executable(tune ${TOOLS_SRC} ${TOOLS_EXTERNAL_SRC})
add_dependencies(tune GENERATE_CLT)
target_link_libraries(tune ${OPENCL_LIBRARIES} ${TIME_LIBRARY} ${MATH_LIBRARY})
set_target_properties( tune PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging"
  OUTPUT_NAME clBLAS-tune )

# CPack configuration; include the executable into the package
install( TARGETS tune
		RUNTIME DESTINATION bin${SUFFIX_BIN}
		LIBRARY DESTINATION lib${SUFFIX_LIB}
		ARCHIVE DESTINATION lib${SUFFIX_LIB}/import
		)

=== src/library/blas/gens/legacy/tests/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################


set(SRC_BLKMUL
    ../blkmul.c
    ${clBLAS_SOURCE_DIR}/library/common/kerngen_core.c
    ${clBLAS_SOURCE_DIR}/library/common/kgen_basic.c
    ${clBLAS_SOURCE_DIR}/library/common/kgen_loop_helper.c
    ${clBLAS_SOURCE_DIR}/library/common/misc.c
    ${clBLAS_SOURCE_DIR}/library/blas/gens/blas_kgen.c
    ${clBLAS_SOURCE_DIR}/library/blas/gens/tile.c
    ${clBLAS_SOURCE_DIR}/library/blas/gens/tile_iter.c
    ${clBLAS_SOURCE_DIR}/library/blas/gens/legacy/blas_kgen_legacy.c
    ${clBLAS_SOURCE_DIR}/library/blas/gens/gen_helper.c
    ${clBLAS_SOURCE_DIR}/library/blas/gens/legacy/gen_helper_legacy.c
    ${clBLAS_SOURCE_DIR}/library/blas/generic/blas_funcs.c
    ${clBLAS_SOURCE_DIR}/library/blas/generic/matrix_dims.c
    ${clBLAS_SOURCE_DIR}/library/blas/generic/matrix_props.c
    ${clBLAS_SOURCE_DIR}/library/common/gens/dblock_kgen.c
    ${clBLAS_SOURCE_DIR}/library/blas/gens/tilemul.c
    ${clBLAS_SOURCE_DIR}/library/blas/gens/fetch.c
    ${clBLAS_SOURCE_DIR}/library/common/kgen_guard.c
    ${clBLAS_SOURCE_DIR}/library/common/list.c
    ${clBLAS_SOURCE_DIR}/library/common/mutex.c
    ${clBLAS_SOURCE_DIR}/library/common/trace_malloc.c
    t_blkmul.c
)

include_directories(${OPENCL_INCLUDE_DIRS} ${clBLAS_SOURCE_DIR} ${clBLAS_SOURCE_DIR}/include
                    ${clBLAS_SOURCE_DIR}/library/blas/include ${clBLAS_SOURCE_DIR}/library/blas/gens)

add_executable(t_blkmul ${SRC_BLKMUL})
target_link_libraries(t_blkmul ${OPENCL_LIBRARIES})
set_target_properties( t_blkmul PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )

# CPack configuration; include the executable into the package
install( TARGETS t_blkmul
		RUNTIME DESTINATION bin${SUFFIX_BIN}
		LIBRARY DESTINATION lib${SUFFIX_LIB}
		ARCHIVE DESTINATION lib${SUFFIX_LIB}/import
		)

=== debian/changelog ===
clblas (2.12-4.1ubuntu2) noble; urgency=medium

  * debian/patches/no-implicit-declarations.patch: Add missing stdlib.h
    includes.  Closes: #1065777.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 09 Apr 2024 21:42:11 +0000

clblas (2.12-4.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:29:36 +0000

clblas (2.12-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062076

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 15:57:31 +0000

clblas (2.12-4) unstable; urgency=medium

  * Team upload.

  [ Jonathan Bergh ]
  * Fix double literals used in single precision functions (Closes: #877316)
  * Fix crash due to null pointer after compile failure (Closes: #921611)
  * Fix issue where variables are not declared in outermost scope
    (Closes: #921890)

  [ tony mancill ]
  * Use debhelper-compat 13
  * Set Rules-Requires-Root: no in debian/control
  * libclblas-doc now installs docs in /usr/share/doc/libclblas-dev/html
    This seems to be part of the debhelper compat change from 10 to 13
    and matches the behavior of clfft.
  * Update doc-base for actual install directory (libcblas-dev)
  * Document uninstalled files in debian/not-installed
  * Update autopkgtest to use AUTOPKGTEST_TMP
  * Bump Standards-Version to 4.6.2
  * Override dh_auto_install-indep for arch-all (only) build
  * Update autopkgtest for new location of example files

 -- tony mancill <tmancill@debian.org>  Thu, 28 Sep 2023 16:21:54 -0700

clblas (2.12-3) unstable; urgency=medium

  * Team upload.
  * Move Vcs to salsa

  [ Bo YU ]
  * Fix ftbfs due to missing python_interp. (Closes: #1025222)

 -- Bastian Germann <bage@debian.org>  Thu, 01 Dec 2022 11:04:47 +0100

clblas (2.12-2) unstable; urgency=medium

  * Team upload
  * Drop unneeded B-D python (Closes: #942963)
  * Make the build reproducible (Closes: #891073)

 -- Bastian Germann <bage@debian.org>  Wed, 30 Nov 2022 20:40:57 +0100

clblas (2.12-1) unstable; urgency=medium

  * New upstream release
  * Rebase patch queue
    - Update disable-multilib-cflags.patch
    - Refresh fix-pthread-linkage.patch
    - Refresh use-boost-dynamic-libs.patch
    - Drop Support-for-altivec-on-powerpc64-P8-systems-262.patch, applied
      upstream
  * Add patch fixing builds without tests
    - New patch Detect-CBLAS-when-building-the-client.patch
  * Add new build dependency on BLAS
  * Upgrade packaging to debhelper 10
  * Drop superfluous Testsuite field

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 21 Jan 2017 16:55:05 +0000

=== debian/control ===
Source: clblas
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>,
           Jonathan Bergh <bergh.jonathan@gmail.com>
Section: science
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), cmake,
               debhelper-compat (= 13),
               libblas-dev,
               libboost-program-options-dev,
               ocl-icd-opencl-dev | opencl-dev,
               python3-dev
Build-Depends-Indep: doxygen
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/clblas
Vcs-Git: https://salsa.debian.org/science-team/clblas.git
Homepage: https://github.com/clMathLibraries/clBLAS
Rules-Requires-Root: no

Package: libclblas2t64
Provides: ${t64:Provides}
Replaces: libclblas2
Breaks: libclblas2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: OpenCL BLAS library
 This library provides an implementation of the Basic Linear Algebra
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU
 hardware.
 .
 This package provides the shared library.

Package: libclblas-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libclblas2t64 (= ${binary:Version}),
         ocl-icd-opencl-dev | opencl-dev
Suggests: libclblas-doc
Description: development files for clBLAS
 This library provides an implementation of the Basic Linear Algebra
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU
 hardware.
 .
 This package provides the development files.

Package: libclblas-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-mathjax
Description: documentation for clBLAS
 This library provides an implementation of the Basic Linear Algebra
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU
 hardware.
 .
 This package provides the documentation.

Package: clblas-client
Architecture: any
Multi-Arch: foreign
Section: utils
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libclblas2t64 (= ${binary:Version})
Breaks: libclblas-bin (<< 2.10-4)
Provides: libclblas-bin
Replaces: libclblas-bin (<< 2.10-4)
Description: client program for clBLAS
 This library provides an implementation of the Basic Linear Algebra
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU
 hardware.
 .
 This package provides the client program.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Fixes FTBFS on mips64* architectures. See #805893.
#DEB_HOST_ARCH := $(shell dpkg-architecture --query DEB_HOST_ARCH)
include /usr/share/dpkg/architecture.mk
ifneq (,$(filter mips64%,$(DEB_HOST_ARCH)))
DEB_CFLAGS_MAINT_APPEND += -mxgot
DEB_CXXFLAGS_MAINT_APPEND += -mxgot
endif

export BUILD_OPTIONS = \
	-DBUILD_CLIENT=ON \
	-DBUILD_KTEST=OFF \
	-DBUILD_PERFORMANCE=OFF \
	-DBUILD_RUNTIME=ON \
	-DBUILD_SAMPLE=OFF \
	-DBUILD_SHARED_LIBS=ON \
	-DBUILD_TEST=OFF \
	-DSUFFIX_LIB="/$(DEB_TARGET_MULTIARCH)"

%:
	dh $@ --sourcedirectory=src

override_dh_auto_clean:
	dh_auto_clean
	find . -name "*.pyc" -delete

override_dh_auto_configure:
	dh_auto_configure -- $(BUILD_OPTIONS)

override_dh_auto_build-indep:
	cd doc && doxygen clBLAS.doxy

override_dh_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --indep

override_dh_compress-indep:
	dh_compress --indep --exclude=examples

override_dh_auto_install-indep:
	# nothing to do here
	#
	# dh-compat 13 invokes this target, which invokes cmake install resulting
	# in a build failure when building with "--arch-all --no-arch-any"
	# Documentation is installed via other targets.

=== debian/tests/control ===
Tests: build-examples
Depends: build-essential,
         cmake,
         libclblas-dev,
         libclblas-doc
Restrictions: allow-stderr
